
/**
 * Account class holds the identifier, name and current balance
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Account
{
    // instance variables
    private int accountNumber;
    private float balance;

    /**
     * Constructor for objects of class Account
     * 
     * @param  num   the account number
     */
    public Account(int num)
    {
        // initialise instance variables
        accountNumber = num;
        balance = 0;
    }

    /**
     * Accessor method for account number
     */
    public int getAccountNumber()
    {
        return accountNumber;
    }

    /**
     * Accessor method for balance
     */
    public float getBalance()
    {
        return balance;
    }

    /**
     * Add the transaction amount to the balance.
     * The transaction is not allowed if balance + amt < 0.
     * Print a message if that happens, otherwise update the balance.
     * 
     * @param  amt   the transaction amount
    */
    public float updateBalance(float amt)
    {
        if (balance + amt < 0)
        {
            System.out.println("Transaction disallowed");
        }
        else
        {
            balance += amt;
        }
        return balance;
    }

    /**
     * Print account number, name and current balance
     */
    public void report()
    {
        System.out.println(accountNumber + " " + balance);
    }

    /**
     * Convert an account object to a string representation
     */
    public String toString()
    {
        return "Account number: " + accountNumber + " has balance $" + balance;
    }
}
