
/**
 * A transaction consists of an account reference and an amount
 * A transaction must only be processed once.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Transaction
{
    // instance variables
    private Account transactionAccount;
    private float amount;
    private boolean processed;          // set to true after processing transaction

    /**
     * Constructor for objects of class Transaction
     * @param  acct   reference to the transaction account
     * @param  amt    the amount of the transaction (may be negative)
     */
    public Transaction(Account acct, float amt)
    {
        // initialise instance variables
        transactionAccount = acct;
        amount = amt;
        processed = false;
    }

    /**
     * To process the transaction, call the updateBalance method in the account object.
     * Also report the result of the transaction.
     */
    public void process()
    {
        if (processed)
        {
            System.out.println("Transaction already processed");
        }
        else if (transactionAccount == null)
        {
            System.out.println("Account does not exist");
            processed = true;
        }
        else
        {
            transactionAccount.updateBalance(amount);
            transactionAccount.report();
            processed = true;
        }
    }
}
